/**
 * NOTE: This class is auto generated by the akka-scala (beta) swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * For any issue or feedback, please open a ticket via https://github.com/swagger-api/swagger-codegen/issues/new
 */
package io.swagger.client.api

import io.swagger.client.core._
import io.swagger.client.core.CollectionFormats._
import io.swagger.client.core.ApiKeyLocations._

object AuthAPIApi {

  /**
   * Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
   * 
   * Expected answers:
   *   code 200 : String (Ключ доступа)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param login Имя пользователя
   * @param salt Соль (см. /auth/start)
   * @param response Вычисленный хэш
   */
  def authLoginPost(login: String, salt: String, response: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.POST, "https://www.1gb.ru/api", "/auth/login", "application/json")
      .withQueryParam("login", login)
      .withQueryParam("salt", salt)
      .withQueryParam("response", response)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
   * 
   * Expected answers:
   *   code 200 : String (Соль для авторизации)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param login Имя пользователя
   */
  def authStartGet(login: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/auth/start", "application/json")
      .withQueryParam("login", login)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
      

}

