/**
 * NOTE: This class is auto generated by the akka-scala (beta) swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * For any issue or feedback, please open a ticket via https://github.com/swagger-api/swagger-codegen/issues/new
 */
package io.swagger.client.api

import io.swagger.client.model.Inline_response_200_3
import io.swagger.client.model.Inline_response_200_4
import io.swagger.client.core._
import io.swagger.client.core.CollectionFormats._
import io.swagger.client.core.ApiKeyLocations._

object DNSApi {

  /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param addDnsZone зона, которую необходимо создать
   * @param addDnsRecord 
   * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
   * @param bindOnly 
   */
  def dnsAddGet(token_: String, addDnsZone: String, addDnsRecord: Option[String] = None, iisSiteForDns: Option[String] = None, bindOnly: Option[Boolean] = None): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/add", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("add_dns_zone", addDnsZone)
      .withQueryParam("add_dns_record", addDnsRecord)
      .withQueryParam("iis_site_for_dns", iisSiteForDns)
      .withQueryParam("bind_only", bindOnly)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID домена из списка /dns/list
   * @param bindTo домен, к которому необходимо сделать привязку
   */
  def dnsBindGet(token_: String, key_: Int, bindTo: Option[String] = None): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/bind", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("bind_to", bindTo)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_3] (Список доменных имён)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def dnsListGet(token_: String): ApiRequest[Seq[Inline_response_200_3]] =
    ApiRequest[Seq[Inline_response_200_3]](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_3]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_4] (Информация по продлению доменов)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def dnsProlongListGet(token_: String): ApiRequest[Seq[Inline_response_200_4]] =
    ApiRequest[Seq[Inline_response_200_4]](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/prolong/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_4]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID домена из /dns/list
   * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
   * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
   * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
   * @param dnsName Имя записи, либо &#39;@&#39; для корневой
   * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
   */
  def dnsRawGet(token_: String, key_: Int, sDel: Int, sAdd: Int, dnsType: String, dnsName: String, dnsValue: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/raw", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("s_del", sDel)
      .withQueryParam("s_add", sAdd)
      .withQueryParam("dns_type", dnsType)
      .withQueryParam("dns_name", dnsName)
      .withQueryParam("dns_value", dnsValue)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID домена из /dns/list
   * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
   * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
   */
  def dnsRawManagedmxGet(token_: String, key_: Int, managedMx: Int, updManagedMx: Int): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/raw/managedmx", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("managed_mx", managedMx)
      .withQueryParam("upd_managed_mx", updManagedMx)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
      

}

