/**
 * NOTE: This class is auto generated by the akka-scala (beta) swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * For any issue or feedback, please open a ticket via https://github.com/swagger-api/swagger-codegen/issues/new
 */
package io.swagger.client.api

import io.swagger.client.model.Inline_response_200
import io.swagger.client.model.Inline_response_200_1
import io.swagger.client.model. 
import io.swagger.client.model.Inline_response_200_4
import io.swagger.client.model.Inline_response_200_5
import io.swagger.client.model.Inline_response_200_6
import io.swagger.client.model.Inline_response_200_10
import io.swagger.client.model.Inline_response_200_14
import io.swagger.client.core._
import io.swagger.client.core.CollectionFormats._
import io.swagger.client.core.ApiKeyLocations._

object DefaultApi {

  /**
   * Возвращает текущий баланс аккаунта
   * 
   * Expected answers:
   *   code 200 : Double (Текущий баланс аккаунта хостинга)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def balanceGet(token_: String): ApiRequest[Double] =
    ApiRequest[Double](ApiMethods.GET, "https://www.1gb.ru/api", "/balance", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Double](200)
      .withDefaultErrorResponse[String]
        /**
   * Возвращает текущий баланс аккаунта лицензий
   * 
   * Expected answers:
   *   code 200 : Double (Текущий баланс аккаунта лицензий)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def balanceLicGet(token_: String): ApiRequest[Double] =
    ApiRequest[Double](ApiMethods.GET, "https://www.1gb.ru/api", "/balance.lic", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Double](200)
      .withDefaultErrorResponse[String]
        /**
   * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200] (Информация по дебету аккаунта)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def billingDebtGet(token_: String): ApiRequest[Seq[Inline_response_200]] =
    ApiRequest[Seq[Inline_response_200]](ApiMethods.GET, "https://www.1gb.ru/api", "/billing/debt", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200]](200)
      .withDefaultErrorResponse[String]
        /**
   * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_1] (Информация об аккаунте)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def billingInfoGet(token_: String): ApiRequest[Seq[Inline_response_200_1]] =
    ApiRequest[Seq[Inline_response_200_1]](ApiMethods.GET, "https://www.1gb.ru/api", "/billing/info", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_1]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 :   (Ограничения аккаунта)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def billingLimitsGet(token_: String): ApiRequest[ ] =
    ApiRequest[ ](ApiMethods.GET, "https://www.1gb.ru/api", "/billing/limits", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[ ](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_4] (Информация по продлению доменов)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def dnsProlongListGet(token_: String): ApiRequest[Seq[Inline_response_200_4]] =
    ApiRequest[Seq[Inline_response_200_4]](ApiMethods.GET, "https://www.1gb.ru/api", "/dns/prolong/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_4]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param addEmail Адрес почтового ящика, который необходимо создать
   */
  def emailAddGet(token_: String, addEmail: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/email/add", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("add_email", addEmail)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ Адрес почтового ящика, подлежащего удалению
   */
  def emailAliasDeleteGet(token_: String, key_: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/email/alias/delete", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_5] (Список псевдонимов почтовых ящиков)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def emailAliasListGet(token_: String): ApiRequest[Seq[Inline_response_200_5]] =
    ApiRequest[Seq[Inline_response_200_5]](ApiMethods.GET, "https://www.1gb.ru/api", "/email/alias/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_5]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ Адрес почтового ящика, подлежащего удалению
   */
  def emailDeleteGet(token_: String, key_: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/email/delete", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_6] (Список почтовых ящиков)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def emailListGet(token_: String): ApiRequest[Seq[Inline_response_200_6]] =
    ApiRequest[Seq[Inline_response_200_6]](ApiMethods.GET, "https://www.1gb.ru/api", "/email/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_6]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Int (Идентификатор последнего уведомления в аудите)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def updatesLastGet(token_: String): ApiRequest[Int] =
    ApiRequest[Int](ApiMethods.GET, "https://www.1gb.ru/api", "/updates/last", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Int](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_10] (Список записей аудита)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID первой записи для показа или 0 для показа всех записей
   */
  def updatesListGet(token_: String, key_: Int): ApiRequest[Seq[Inline_response_200_10]] =
    ApiRequest[Seq[Inline_response_200_10]](ApiMethods.GET, "https://www.1gb.ru/api", "/updates/list", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[Seq[Inline_response_200_10]](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID сайта, полученный из /website/list
   */
  def websiteDeleteGet(token_: String, key_: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/website/delete", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * 
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_14] (Список сайтов аккаунта)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def websiteListGet(token_: String): ApiRequest[Seq[Inline_response_200_14]] =
    ApiRequest[Seq[Inline_response_200_14]](ApiMethods.GET, "https://www.1gb.ru/api", "/website/list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_14]](200)
      .withDefaultErrorResponse[String]
      

}

