/**
 * NOTE: This class is auto generated by the akka-scala (beta) swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * For any issue or feedback, please open a ticket via https://github.com/swagger-api/swagger-codegen/issues/new
 */
package io.swagger.client.api

import io.swagger.client.model.Inline_response_200_11
import io.swagger.client.model.Inline_response_200_12
import io.swagger.client.model.Inline_response_200_13
import io.swagger.client.core._
import io.swagger.client.core.CollectionFormats._
import io.swagger.client.core.ApiKeyLocations._

object VDSHyperVOpenVZApi {

  /**
   * Изменение параметров уже существующего VDS
   * 
   * Expected answers:
   *   code 200 : String (ID VDS)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param &#x60;type&#x60; Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
   * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
   * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
   * @param crHvcpu Количество ядер CPU. По умолчанию 2
   * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
   * @param forceMemo 
   * @param hv1gbPanelVersion 
   * @param panelInstall Необходимо ли установить панель 1Gb на VDS
   * @param crSsd1 Создать всю систему на SSD
   * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
   */
  def vdsCreateGet(token_: String, &#x60;type&#x60;: Option[String] = None, crHvmem: Option[Int] = None, crHvdsk: Option[Int] = None, crHvcpu: Option[Int] = None, template: Option[String] = None, forceMemo: Option[String] = None, hv1gbPanelVersion: Option[String] = None, panelInstall: Option[Boolean] = None, crSsd1: Option[Boolean] = None, crHvAllSystem: Option[Boolean] = None): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/create", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("type", &#x60;type&#x60;)
      .withQueryParam("cr_hvmem", crHvmem)
      .withQueryParam("cr_hvdsk", crHvdsk)
      .withQueryParam("cr_hvcpu", crHvcpu)
      .withQueryParam("template", template)
      .withQueryParam("force_memo", forceMemo)
      .withQueryParam("hv_1gb_panel_version", hv1gbPanelVersion)
      .withQueryParam("panel_install", panelInstall)
      .withQueryParam("cr_ssd1", crSsd1)
      .withQueryParam("cr_hv_all_system", crHvAllSystem)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Предоставляет функционал для удаления VDS
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   * @param forceCritical Если true, VDS будет удален срочно
   */
  def vdsDeleteGet(token_: String, key_: Int, forceCritical: Option[Boolean] = None): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/delete", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("force_critical", forceCritical)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
   * 
   * Expected answers:
   *   code 200 : String (IP-адрес успешно добавлен)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   */
  def vdsIpAddGet(token_: String, key_: Int): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/ip/add", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Этот вызов позволяет отвязать IP адрес от VDS
   * 
   * Expected answers:
   *   code 200 : String (IP-адрес успешно удалён)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   * @param delIp IP адрес, который необходимо удалить
   */
  def vdsIpDeleteGet(token_: String, key_: Int, delIp: String): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/ip/delete", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("del_ip", delIp)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Список IP-адресов виртуальных серверов
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_11] (Список IP-адресов виртуальных серверов)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   */
  def vdsIpListGet(token_: String, key_: Option[Int] = None): ApiRequest[Seq[Inline_response_200_11]] =
    ApiRequest[Seq[Inline_response_200_11]](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/ip/list", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[Seq[Inline_response_200_11]](200)
      .withDefaultErrorResponse[String]
        /**
   * Позволяет получить список виртуальных серверов
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_12] (Список виртуальных серверов)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
   */
  def vdsListGet(token_: String, key_: Option[Int] = None): ApiRequest[Seq[Inline_response_200_12]] =
    ApiRequest[Seq[Inline_response_200_12]](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/list", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[Seq[Inline_response_200_12]](200)
      .withDefaultErrorResponse[String]
        /**
   * Предоставляет функционал для перезагрузки VDS
   * 
   * Expected answers:
   *   code 200 : String (Возврат строки &#39;OK&#39; означает успех операции)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   */
  def vdsRebootGet(token_: String, key_: Int): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/reboot", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
        /**
   * Позволяет получить список шаблонов виртуальных серверов
   * 
   * Expected answers:
   *   code 200 : Seq[Inline_response_200_13] (Список шаблонов виртуальных серверов)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   */
  def vdsTemplatesListGet(token_: String): ApiRequest[Seq[Inline_response_200_13]] =
    ApiRequest[Seq[Inline_response_200_13]](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/templates-list", "application/json")
      .withQueryParam("_token_", token_)
      .withSuccessResponse[Seq[Inline_response_200_13]](200)
      .withDefaultErrorResponse[String]
        /**
   * Создание новых VDS с произвольными характеристиками
   * 
   * Expected answers:
   *   code 200 : String (Параметры VDS успешно обновлены)
   *   code 0 : String (Общая ошибка от сервера)
   * 
   * @param token_ Ключ доступа, полученный при авторизации
   * @param key_ ID виртуального сервера, полученный из /vds/list
   * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
   * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
   * @param crHvcpu Количество ядер CPU. По умолчанию 2
   */
  def vdsUpdateGet(token_: String, key_: Int, crHvmem: Option[Int] = None, crHvdsk: Option[Int] = None, crHvcpu: Option[Int] = None): ApiRequest[String] =
    ApiRequest[String](ApiMethods.GET, "https://www.1gb.ru/api", "/vds/update", "application/json")
      .withQueryParam("_token_", token_)
      .withQueryParam("_key_", key_)
      .withQueryParam("cr_hvmem", crHvmem)
      .withQueryParam("cr_hvdsk", crHvdsk)
      .withQueryParam("cr_hvcpu", crHvcpu)
      .withSuccessResponse[String](200)
      .withDefaultErrorResponse[String]
      

}

